package org.t2framework.lucy;

import org.t2framework.commons.meta.BeanDesc;
import org.t2framework.lucy.config.meta.InstanceConfig;
import org.t2framework.lucy.spi.Behavior;
import org.t2framework.lucy.spi.LucyConfiguration;

/**
 * {@link ConfigBinder} is the interface to bind component and behavior.
 * 
 * @author shot
 */
public interface ConfigBinder {

	/**
	 * Add {@link Behavior}.
	 * 
	 * @param behavior
	 */
	void addBehavior(Class<? extends Behavior> behavior);

	/**
	 * Add {@link InstanceConfig}.
	 * 
	 * @param instanceConfig
	 */
	void addInstanceConfig(InstanceConfig instanceConfig);

	/**
	 * Bind {@link BeanDesc} and {@link Behavior}.This result is as
	 * {@link ConfigBindResult}.
	 * 
	 * @param <T>
	 * @param beanDesc
	 * @return
	 */
	<T> ConfigBindResult bind(BeanDesc<T> beanDesc);

	/**
	 * Load configuration.
	 * 
	 * @param conf
	 * @return
	 */
	ConfigBinder loadConfiguration(final LucyConfiguration conf);
}
