package org.t2framework.lucy;

/**
 * 
 * {@.en Lifecycle of {@link Lucy} itself and components.}
 * 
 * <br />
 * 
 * {@.ja {@link Lucy}とコンポーネントのライフサイクルを規定するenumです.}
 * 
 * @author shot
 * 
 */
public enum Lifecycle {
	/**
	 * {@.en Container configuration phase.}
	 * 
	 * <br />
	 * 
	 * {@.ja {@link Lucy}自身の設定フェーズです.}
	 */
	CONTAINER_CONFIG,

	/**
	 * Class loading phase.
	 */
	CLASS_LOADING,

	/**
	 * Component creating phase.
	 */
	COMPONENT_CREATING,

	/**
	 * The phase just after components are created.
	 */
	COMPONENT_CREATED,

	/**
	 * Component initializing phase.
	 */
	COMPONENT_INITIALIZE,

	/**
	 * Component destroy phase.
	 */
	COMPONENT_DESTROY;

	/* CONTAINER_SHUTDOWN */

	/**
	 * Get component creation lifecycle.
	 */
	public static Lifecycle[] getComponentLifecycle() {
		return new Lifecycle[] { CLASS_LOADING, COMPONENT_CREATING,
				COMPONENT_CREATED, COMPONENT_INITIALIZE, COMPONENT_DESTROY };
	}

	/**
	 * Get container creation lifecycle.
	 * 
	 * @return
	 */
	public static Lifecycle[] getContainerLifecycle() {
		return new Lifecycle[] { CONTAINER_CONFIG };
	}
}
