package org.t2framework.lucy;

/**
 * Component registration class for {@link Lucy}.This interface is implemented
 * if external configured components should be stored to {@link Lucy}.
 * 
 * @author shot
 * 
 * @param <R>
 */
public interface LucyComponentRegistrar<R> {

	/**
	 * Register by resource represented as R.
	 * 
	 * @param lucy
	 * @param resource
	 */
	void register(Lucy lucy, R resource);

	/**
	 * True if given resource is acceptable.
	 * 
	 * @param resource
	 * @return
	 */
	boolean accepts(Object resource);
}
