package org.t2framework.lucy;

import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.t2framework.commons.util.Assertion;
import org.t2framework.commons.util.CollectionsUtil;
import org.t2framework.commons.util.Reflections.ClassUtil;

/**
 * Utility class for {@link Lucy}.This class is not expected to use by
 * application developer.
 * 
 * @author shot
 * 
 */
public class LucyUtil {

	private static Set<Class<?>> simpleTypes = CollectionsUtil.newHashSet();

	static {
		simpleTypes.add(String.class);
		simpleTypes.add(Number.class);
		simpleTypes.add(Date.class);
		simpleTypes.add(java.sql.Date.class);
		simpleTypes.add(Calendar.class);
		simpleTypes.add(List.class);
		simpleTypes.add(Map.class);
		simpleTypes.add(Set.class);
		simpleTypes.add(Lucy.class);
	};

	/**
	 * Check if the class is simple type or not.Simple type means it is not
	 * needed dependency injecting process which will occur at component
	 * building process at {@link Lucy}.
	 * 
	 * @param c
	 * @return
	 */
	public static boolean isSimpleType(Class<?> c) {
		Class<?> clazz = ClassUtil.toWrapperClass(Assertion.notNull(c));
		for (Class<?> candidate : simpleTypes) {
			if (candidate.isAssignableFrom(clazz)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * Add type.
	 * 
	 * @param type
	 */
	public static void addSimpleTypes(Class<?> type) {
		simpleTypes.add(Assertion.notNull(type));
	}
}
