package org.t2framework.lucy.annotation.core;

import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 
 * {@.en &#064;DestroyMethod is an annotation to notify this annotated method is
 * called at disposing time of component by Lucy.}
 * 
 * <br />
 * 
 * {@.ja &#064;DestroyMethodはLucyの破棄するタイミングで呼ばれることを保証するアノテーションです．}
 * 
 * @author taichi
 * 
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
@Inherited
public @interface DestroyMethod {

}