package org.t2framework.lucy.aop;

import java.util.List;

import org.t2framework.commons.aop.spi.Aspect;
import org.t2framework.commons.aop.spi.Interceptor;

/**
 * AspectCreator creates {@link Aspect} from given regular expression and list
 * of {@link Interceptor}.
 * 
 * @author shot
 * 
 */
public interface AspectCreator {

	/**
	 * Create {@link Aspect} by given regular expression and list of
	 * {@link Interceptor}.
	 * 
	 * @param regex
	 * @param interceptors
	 * @return
	 */
	Aspect createAspect(String regex, List<Interceptor> interceptors);
}
