package org.t2framework.lucy.aop;

import java.util.List;
import java.util.Map;

import org.t2framework.commons.aop.spi.Aspect;

/**
 * Aspect descriptor interface.It has original class, enhanced class, name,
 * aspects.
 * 
 * @author shot
 */
public interface AspectDesc {

	/**
	 * Get original class.
	 * 
	 * @return
	 */
	Class<?> getOriginalClass();

	/**
	 * Get enhanced class.
	 * 
	 * @return
	 */
	Class<?> getEnhancedClass();

	/**
	 * Get enhanced class name.
	 * 
	 * @return
	 */
	String getEnhancedClassName();

	/**
	 * Set enhanced class.
	 * 
	 * @param enhancedClass
	 */
	void setEnhancedClass(Class<?> enhancedClass);

	/**
	 * Set enhanced class name.
	 * 
	 * @param name
	 */
	void setEnhancedClassName(String name);

	/**
	 * Get list of {@link Aspect}.
	 * 
	 * @return
	 */
	List<Aspect> getAspects();

	/**
	 * Get parameters.
	 * 
	 * @return
	 */
	Map<String, Object> getParameters();

	/**
	 * If target is interface or not.
	 * 
	 * @return
	 */
	boolean isInterfaceTarget();

}
