package org.t2framework.lucy.aop;

/**
 * {@link EnhancedClassCache} is simple cache interface of enhanced class.
 * 
 * @author shot
 * 
 */
public interface EnhancedClassCache {

	/**
	 * Get enhanced class from cache.
	 * 
	 * @param <T>
	 * @param originalClass
	 * @return
	 */
	<T> Class<? extends T> get(Class<? extends T> originalClass);

	/**
	 * Cache enhanced class.The original class is the key of cache.
	 * 
	 * @param <T>
	 * @param originalClass
	 * @param enhancedClass
	 */
	<T> void cache(Class<? extends T> originalClass,
			Class<? extends T> enhancedClass);

	/**
	 * Clear cache for the original class.
	 * 
	 * @param <T>
	 * @param originalClass
	 */
	<T> void clear(Class<? extends T> originalClass);

	/**
	 * Clear all cache.
	 */
	void clear();
}
