package org.t2framework.lucy.aop;

import java.util.List;

import org.t2framework.commons.aop.spi.Interceptor;
import org.t2framework.commons.meta.MethodDesc;

/**
 * {@link InterceptorDesc} is a temporal descriptor class for
 * {@link Interceptor}.This implemented class is used internally for aop
 * package.
 * 
 * @author shot
 * 
 */
public interface InterceptorDesc {

	/**
	 * Get target {@link MethodDesc}.
	 * 
	 * @return
	 */
	MethodDesc getMethodDesc();

	/**
	 * Get all {@link Interceptor}.
	 * 
	 * @return
	 */
	List<Interceptor> getInterceptors();
}
