package org.t2framework.lucy.aop;

import java.lang.reflect.AccessibleObject;
import java.util.Map;

import org.t2framework.commons.meta.BeanDesc;

/**
 * InterceptorDescStrategy is a strategy interface to get all interceptors from
 * BeanDesc.
 * 
 * @author shot
 */
public interface InterceptorDescStrategy {

	/**
	 * Assemble AOP information as {@link Map<AccessibleObject,
	 * InterceptorDesc>} from {@link BeanDesc}.
	 * 
	 * @param <T>
	 * @param beanDesc
	 * @param aspectDesc
	 * @return
	 */
	<T> Map<AccessibleObject, InterceptorDesc> assemble(
			final BeanDesc<T> beanDesc, final AspectDesc aspectDesc);
}
