package org.t2framework.lucy.aop.config.impl;

import org.t2framework.commons.el.Expression;
import org.t2framework.commons.meta.ExpressionAware;
import org.t2framework.commons.meta.impl.ExpressionAwareImpl;
import org.t2framework.lucy.aop.config.AspectConfig;
import org.t2framework.lucy.config.meta.impl.AbstractOuterConfig;

/**
 * Abstract aspect config class.
 * 
 * @author shot
 * 
 */
public abstract class AbstractAspectConfig extends AbstractOuterConfig
		implements AspectConfig {

	protected ExpressionAware delegate = new ExpressionAwareImpl();

	public AbstractAspectConfig() {
		super(AspectConfig.class);
	}

	@Override
	public Class<? extends AspectConfig> getType() {
		return AspectConfig.class;
	}

	@Override
	public void add(Expression<?> expression) {
		this.delegate.add(expression);
	}

	@Override
	public Iterable<Expression<?>> getExpressions() {
		return this.delegate.getExpressions();
	}

	@Override
	public boolean hasExpression() {
		return delegate.hasExpression();
	}
}
