package org.t2framework.lucy.aop.config.stax;

import org.t2framework.commons.aop.spi.Pointcut;
import org.t2framework.commons.el.Expression;
import org.t2framework.commons.meta.ConfigContainer;
import org.t2framework.commons.util.StringUtil;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.aop.config.AspectConfig;
import org.t2framework.lucy.aop.config.impl.AspectConfigImpl;
import org.t2framework.lucy.aop.impl.PointcutImpl;
import org.t2framework.lucy.config.stax.AbstractExpressionHandler;
import org.t2framework.lucy.config.stax.Attributes;
import org.t2framework.lucy.config.stax.XmlEventContext;
import org.t2framework.lucy.config.stax.XmlEventHandler;

/**
 * Tag handler for aspect tag.
 * 
 * @author shot
 */
public class AspectTagHandler extends AbstractExpressionHandler implements
		XmlEventHandler {

	@Override
	public void start(XmlEventContext context, Attributes attributes) {
		final String pattern = attributes.getValue("pointcut");
		final Pointcut pointcut = createPointcut(pattern);
		AspectConfig aspectConfig = createAspectConfig(context.getLucy(),
				pointcut);
		context.push(aspectConfig);
	}

	@Override
	public void end(XmlEventContext context, String body) {
		AspectConfig acd = (AspectConfig) context.pop();
		String s = body.trim();
		Expression<Lucy> e = getExpression(s);
		if (e != null) {
			acd.add(e);
		}
		ConfigContainer container = (ConfigContainer) context.peek();
		container.addConfig(acd);
	}

	protected AspectConfig createAspectConfig(Lucy lucy, Pointcut pointcut) {
		return new AspectConfigImpl(lucy, pointcut);
	}

	protected Pointcut createPointcut(String pattern) {
		if (StringUtil.isEmpty(pattern) == false) {
			return new PointcutImpl(pattern);
		} else {
			return new PointcutImpl();
		}
	}
}
