package org.t2framework.lucy.aop.impl;

import java.util.List;

import org.t2framework.commons.aop.AspectAssembler;
import org.t2framework.commons.aop.spi.Interceptor;
import org.t2framework.commons.meta.BeanDesc;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.aop.AspectCreator;

public class AspectAssemblerImpl<C extends Lucy> implements AspectAssembler<C>,
		AspectCreator {

	public AspectAssemblerImpl() {
	}

	@SuppressWarnings("unchecked")
	@Override
	public <T> List<org.t2framework.commons.aop.spi.Aspect> assemble(
			BeanDesc<T> beanDesc, C lucy) {
		return AspectCreationHelper.build(this).doChain(
				(BeanDesc<Object>) beanDesc, lucy);
	}

	@Override
	public org.t2framework.commons.aop.spi.Aspect createAspect(String regex,
			List<Interceptor> interceptors) {
		return new AspectImpl(regex, interceptors);
	}

}
