package org.t2framework.lucy.aop.impl;

import java.io.Serializable;
import java.util.Arrays;
import java.util.List;

import org.t2framework.commons.aop.spi.Aspect;
import org.t2framework.commons.aop.spi.Interceptor;
import org.t2framework.commons.aop.spi.Pointcut;
import org.t2framework.commons.util.Assertion;

public class AspectImpl implements Aspect, Serializable {

	static final long serialVersionUID = 0L;

	protected List<Interceptor> interceptors;

	protected Pointcut pointcut;

	public AspectImpl(Interceptor... interceptors) {
		this(Arrays.asList(interceptors));
	}

	public AspectImpl(String regex, Interceptor... interceptors) {
		this(regex, Arrays.asList(interceptors));
	}

	public AspectImpl(List<Interceptor> interceptors) {
		this(Pointcut.DEFAULT_REGEX, Assertion.notNull(interceptors));
	}

	public AspectImpl(String regex, List<Interceptor> interceptors) {
		this.interceptors = Assertion.notNull(interceptors);
		this.pointcut = new PointcutImpl(Assertion.notNull(regex));
	}

	@Override
	public Pointcut getPointcut() {
		return pointcut;
	}

	@Override
	public void setPointcut(Pointcut pointcut) {
		this.pointcut = Assertion.notNull(pointcut);
	}

	@Override
	public List<Interceptor> getInterceptors() {
		return interceptors;
	}

}
