package org.t2framework.lucy.aop.impl;

import java.util.List;

import org.t2framework.commons.aop.spi.Interceptor;
import org.t2framework.commons.meta.MethodDesc;
import org.t2framework.commons.util.Assertion;
import org.t2framework.lucy.aop.InterceptorDesc;

public class InterceptorDescImpl implements InterceptorDesc {

	protected MethodDesc methodDesc;

	protected List<Interceptor> interceptors;

	public InterceptorDescImpl(MethodDesc method, List<Interceptor> interceptors) {
		Assertion.notNull(method);
		Assertion.notNull(interceptors);
		this.methodDesc = method;
		this.interceptors = interceptors;
	}

	@Override
	public List<Interceptor> getInterceptors() {
		return interceptors;
	}

	@Override
	public MethodDesc getMethodDesc() {
		return methodDesc;
	}
}
