package org.t2framework.lucy.aop.impl;

import java.io.Serializable;
import java.lang.reflect.Method;
import java.util.regex.Pattern;

import org.t2framework.commons.aop.spi.Pointcut;
import org.t2framework.commons.util.Assertion;

public class PointcutImpl implements Pointcut, Serializable {

	static final long serialVersionUID = 0L;

	protected String regex;

	protected Pattern pattern;

	public PointcutImpl() {
		this(DEFAULT_REGEX);
	}

	public PointcutImpl(String regexes) {
		this.regex = Assertion.notNull(regexes);
		this.pattern = Pattern.compile(regexes);
	}

	@Override
	public Pattern getPattern() {
		return this.pattern;
	}

	protected boolean match(final String methodName) {
		if (this.pattern.matcher(methodName).matches()) {
			return true;
		}
		return false;
	}

	@Override
	public String getPatternString() {
		return regex;
	}

	@Override
	public boolean isApplied(Method method) {
		final String methodName = Assertion.notNull(method).getName();
		return match(methodName);
	}

}
