package org.t2framework.lucy.aop.javassist;

import java.util.List;

import org.t2framework.commons.aop.spi.Aspect;
import org.t2framework.lucy.aop.AspectDesc;
import org.t2framework.lucy.aop.EnhancedClassBuilder;
import org.t2framework.lucy.aop.InterceptorDescStrategy;
import org.t2framework.lucy.aop.impl.AbstractAopEngine;
import org.t2framework.lucy.aop.impl.AspectDescImpl;
import org.t2framework.lucy.aop.util.AopUtil;

/**
 * JavassistAopEngineImpl is implementation for Javassist byte code enhance AOP.
 * 
 * @author shot
 * @author c9katayama
 */
public class JavassistAopEngineImpl extends AbstractAopEngine {

	public JavassistAopEngineImpl() {
	}

	public JavassistAopEngineImpl(InterceptorDescStrategy strategy) {
		super(strategy);
	}

	@Override
	protected <T> AspectDesc createAspectDesc(Class<T> originalClass,
			List<Aspect> aspects) {
		return new AspectDescImpl(originalClass, AopUtil
				.createEnhancedClassName(originalClass), aspects);
	}

	@Override
	protected <T> EnhancedClassBuilder<T> createBuilder(
			InterceptorDescStrategy strategy) {
		return new JavassistEnhancedClassBuilderImpl<T>(strategy);
	}
}
