package org.t2framework.lucy.aop.javassist.meta.impl;

public class AnnotationWriterUtil {

	public static void writeStringBody(Object value, StringBuilder body) {
		body.append("{return \"");
		body.append(value);
		body.append("\";}");
	}

	public static void writeClassBody(Object value, StringBuilder body) {
		body.append("{return ");
		body.append(value.getClass().getName());
		body.append(".class;}");
	}

	@SuppressWarnings("unchecked")
	public static void writeEnumBody(Object value, StringBuilder body) {
		if (Enum.class.isAssignableFrom(value.getClass()) == false) {
			throw new IllegalStateException();
		}
		final Enum e = (Enum) value;
		final String name = e.getDeclaringClass().getName();
		body.append("{return ");
		body.append(name + "." + value.toString());
		body.append(";}");
	}

	public static void writeObjectBody(Object value, StringBuilder body) {
		body.append("{return ");
		body.append(value);
		body.append(";}");
	}

}
