package org.t2framework.lucy.aop.javassist.module;

import org.t2framework.commons.aop.AopEngine;
import org.t2framework.commons.meta.spi.AnnotationConfigSupport;
import org.t2framework.lucy.aop.javassist.JavassistAopEngineImpl;
import org.t2framework.lucy.aop.javassist.behavior.JavassistAspectBehavior;
import org.t2framework.lucy.aop.javassist.meta.impl.AnnotationConfigSupportImpl;
import org.t2framework.lucy.aop.module.AbstractLucyAopModule;
import org.t2framework.lucy.spi.Behavior;

public class JavassistAopModuleImpl extends AbstractLucyAopModule {

	protected static AnnotationConfigSupport javassistSupport = new AnnotationConfigSupportImpl();

	protected static AopEngine javassistAopEngine = new JavassistAopEngineImpl();

	@Override
	public Class<? extends Behavior> getAspectBehaviorClass() {
		return JavassistAspectBehavior.class;
	}

	@Override
	public AnnotationConfigSupport getAnnotationConfigSupport() {
		return javassistSupport;
	}

	@Override
	public AopEngine getAopEngine() {
		return javassistAopEngine;
	}

}
