package org.t2framework.lucy.aop.javassist.util;

import java.util.Map;

import org.t2framework.commons.util.Assertion;
import org.t2framework.commons.util.CollectionsUtil;
import org.t2framework.commons.util.Reflections.ClassLoaderUtil;

import javassist.LoaderClassPath;

/**
 * @author shot
 */
public class ClassPoolUtil {

	protected static Map<ClassLoader, LucyClassPool> cache = CollectionsUtil
			.newSynchronizedWeakHashMap();

	public static LucyClassPool getClassPool(final Class<?> clazz) {
		Assertion.notNull(clazz);
		ClassLoader classLoader = ClassLoaderUtil.getClassLoader(clazz);
		LucyClassPool pool = cache.get(classLoader);
		if (pool != null) {
			return pool;
		}
		pool = new LucyClassPool();
		pool.appendClassPath(new LoaderClassPath(classLoader));
		cache.put(classLoader, pool);
		return pool;
	}

	public static void clearCache() {
		cache.clear();
	}

}
