package org.t2framework.lucy.aop.module;

import org.t2framework.commons.aop.AopEngine;
import org.t2framework.commons.meta.spi.AnnotationConfigSupport;
import org.t2framework.lucy.aop.config.stax.AspectTagHandler;
import org.t2framework.lucy.config.stax.XmlEventHandler;
import org.t2framework.lucy.module.LucyAopModule;

public abstract class AbstractLucyAopModule implements LucyAopModule {

	protected static AspectTagHandler handler = new AspectTagHandler();

	@Override
	public XmlEventHandler getAspectTagHandler() {
		return handler;
	}

	@SuppressWarnings("unchecked")
	@Override
	public <S> S getService(Class<? super S> serviceClass) {
		if (XmlEventHandler.class.isAssignableFrom(serviceClass)) {
			return (S) getAspectTagHandler();
		} else if (serviceClass == getAspectBehaviorClass()) {
			return (S) getAspectBehaviorClass();
		} else if (AnnotationConfigSupport.class.isAssignableFrom(serviceClass)) {
			return (S) getAnnotationConfigSupport();
		} else if (AopEngine.class.isAssignableFrom(serviceClass)) {
			return (S) getAopEngine();
		}
		return null;
	}

}
