package org.t2framework.lucy.aop.proxy;

import java.util.List;

import org.t2framework.commons.aop.spi.Aspect;
import org.t2framework.lucy.aop.AspectDesc;
import org.t2framework.lucy.aop.EnhancedClassBuilder;
import org.t2framework.lucy.aop.InterceptorDescStrategy;
import org.t2framework.lucy.aop.impl.AbstractAopEngine;
import org.t2framework.lucy.aop.impl.AspectDescImpl;

/**
 * ProxyAopEngineImpl is implementation for proxy base AOP.
 * 
 * @author c9katayama
 * 
 */
public class ProxyAopEngineImpl extends AbstractAopEngine {

	@Override
	protected <T> AspectDesc createAspectDesc(Class<T> originalClass,
			List<Aspect> aspects) {
		return new AspectDescImpl(originalClass, aspects);
	}

	@Override
	protected <T> EnhancedClassBuilder<T> createBuilder(
			InterceptorDescStrategy strategy) {
		return new ProxyEnhancedClassBuilderImpl<T>();
	}
}
