package org.t2framework.lucy.aop.proxy;

import java.lang.reflect.Proxy;

import org.t2framework.commons.util.Reflections.ClassLoaderUtil;
import org.t2framework.lucy.aop.AspectDesc;
import org.t2framework.lucy.aop.EnhancedClassBuilder;
import org.t2framework.lucy.aop.InterceptorDescStrategy;
import org.t2framework.lucy.aop.exception.AspectException;

/**
 * Build proxy class.
 * 
 * @author AKatayama
 * 
 * @param <T>
 */
public class ProxyEnhancedClassBuilderImpl<T> implements
		EnhancedClassBuilder<T> {

	public void setInterceptorDescStrategy(InterceptorDescStrategy strategy) {
	};

	@Override
	@SuppressWarnings("unchecked")
	public Class<T> build(AspectDesc aspectDesc) {
		Class<?> targetClass = aspectDesc.getOriginalClass();
		Class<?>[] proxyInterfaces;
		if (targetClass.isInterface()) {
			proxyInterfaces = new Class[] { targetClass };
		} else {
			proxyInterfaces = targetClass.getInterfaces();
			if (proxyInterfaces == null) {
				// TODO
				throw new AspectException(new IllegalArgumentException(
						"Cannot create proxy instance."));
			}
		}
		return (Class<T>) Proxy.getProxyClass(ClassLoaderUtil
				.getClassLoader(targetClass), proxyInterfaces);
	}
}
