package org.t2framework.lucy.aop.proxy.module;

import org.t2framework.commons.aop.AopEngine;
import org.t2framework.commons.meta.spi.AnnotationConfigSupport;
import org.t2framework.lucy.aop.module.AbstractLucyAopModule;
import org.t2framework.lucy.aop.proxy.ProxyAopEngineImpl;
import org.t2framework.lucy.aop.proxy.behavior.ProxyAspectBehavior;
import org.t2framework.lucy.aop.proxy.meta.impl.NoOpAnnotationConfigSupportImpl;
import org.t2framework.lucy.spi.Behavior;

/**
 * AOP module for proxy based AOP.
 * 
 * @author c9katayama
 */
public class ProxyAopModuleImpl extends AbstractLucyAopModule {

	protected static AnnotationConfigSupport support = new NoOpAnnotationConfigSupportImpl();

	protected static AopEngine aopEngine = new ProxyAopEngineImpl();

	@Override
	public AnnotationConfigSupport getAnnotationConfigSupport() {
		return support;
	}

	@Override
	public Class<? extends Behavior> getAspectBehaviorClass() {
		return ProxyAspectBehavior.class;
	}

	@Override
	public AopEngine getAopEngine() {
		return aopEngine;
	}
}
