package org.t2framework.lucy.aop.util;

import static org.t2framework.lucy.aop.AopConstants.PREFIX_ENHANCED_CLASS;
import static org.t2framework.lucy.aop.AopConstants.SUFFIX_ENHANCED_CLASS;

import java.util.Set;

import org.t2framework.commons.util.CollectionsUtil;

/**
 * Aop utility class.
 * 
 * @author c9katayama
 * @author shot
 */
public class AopUtil {

	protected static final Set<String> enhancedClassNames = CollectionsUtil
			.newConcurrentHashSet();

	public static String createEnhancedClassName(Class<?> baseClass) {
		final StringBuffer buf = new StringBuffer(200);
		final String targetClassName = baseClass.getName();
		final Package pkg = baseClass.getPackage();
		if (targetClassName.startsWith("java.")
				|| (pkg != null && pkg.isSealed())) {
			buf.append(PREFIX_ENHANCED_CLASS);
		}
		buf.append(targetClassName).append(SUFFIX_ENHANCED_CLASS).append(
				Integer.toHexString(new Object().hashCode()));
		final int length = buf.length();
		for (int i = 0; enhancedClassNames.contains(new String(buf)); ++i) {
			buf.setLength(length);
			buf.append("_").append(i);
		}
		String enhancedClassName = new String(buf);
		enhancedClassNames.add(enhancedClassName);
		return enhancedClassName;
	}

	/**
	 * 
	 * {@.en }
	 * 
	 * <br />
	 * 
	 * {@.ja Javassistが有効かどうかを判定します.}
	 * 
	 * @return boolean
	 */
	public static boolean isJavassistEnabled() {
		try {
			Class.forName("javassist.ClassPool");
			return true;
		} catch (ClassNotFoundException ignore) {
			return false;
		}
	}
}
