package org.t2framework.lucy.behavior;

import org.t2framework.commons.annotation.ConfigurationTarget;
import org.t2framework.commons.annotation.core.Prototype;
import org.t2framework.commons.meta.BeanDesc;
import org.t2framework.commons.meta.ClassDesc;
import org.t2framework.commons.meta.Config;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.config.meta.impl.PrototypeInstanceConfig;

/**
 * 
 * {@.en PrototypeBehavior creates instance every time when it's called.}
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
@ConfigurationTarget( { Prototype.class, PrototypeInstanceConfig.class })
public class PrototypeBehavior extends AbstractComponentCreationBehavior {

	public PrototypeBehavior(BeanDesc<?> beanDesc, ClassDesc<?> classDesc,
			Config cd) {
		super(beanDesc, classDesc, cd);
	}

	@SuppressWarnings("unchecked")
	@Override
	protected <T> T handleComponentCreation(T t, Lucy lucy,
			BeanDesc<Object> beanDesc) {
		if (beanDesc.isSingleton() == false && beanDesc.getComponent() != null) {
			return (T) beanDesc.getComponent();
		} else {
			return getInjector().inject(t, lucy);
		}
	}

}
