package org.t2framework.lucy.config.meta.impl;

import org.t2framework.commons.Constants;
import org.t2framework.lucy.config.meta.InjectConfig;

/**
 * 
 * {@.en A base class for inject tag configuration.}
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
public abstract class AbstractInjectConfig extends AbstractOuterConfig
		implements InjectConfig {

	protected Class<?>[] parameterTypes = Constants.EMPTY_CLASS_ARRAY;

	protected boolean autoinjected = false;

	public AbstractInjectConfig() {
		this(false);
	}

	public AbstractInjectConfig(boolean autoinjected) {
		super(InjectConfig.class);
		this.autoinjected = autoinjected;
	}

	@Override
	public Class<?>[] getParameterTypes() {
		return parameterTypes;
	}

	@Override
	public void setParameterTypes(Class<?>[] paramTypes) {
		this.parameterTypes = paramTypes;
	}

	public boolean isAutoinjected() {
		return autoinjected;
	}

}
