package org.t2framework.lucy.config.meta.impl;

import java.lang.annotation.Annotation;

import org.t2framework.commons.meta.Config;
import org.t2framework.commons.meta.ConfigContainer;
import org.t2framework.commons.meta.ConfigType;

public abstract class AbstractOuterConfig implements Config {

	protected OuterConfigDelegate delegate;

	public AbstractOuterConfig(Class<?> type) {
		this(type, ConfigType.OUTER);
	}

	public AbstractOuterConfig(Class<?> type, ConfigType configType) {
		delegate = new OuterConfigDelegate(type, configType);
	}

	public AbstractOuterConfig(Class<?> type, ConfigType configType,
			ConfigContainer configContainer) {
		delegate = new OuterConfigDelegate(type, configType, configContainer);
	}

	@Override
	public Annotation getAnnotation() {
		return delegate.getAnnotation();
	}

	@Override
	public ConfigType getConfigType() {
		return delegate.getConfigType();
	}

	@Override
	public boolean hasAnnotation() {
		return delegate.hasAnnotation();
	}

	@Override
	public Class<?> getType() {
		return delegate.getType();
	}

	@Override
	public ConfigContainer getConfigContainer() {
		return delegate.getConfigContainer();
	}
}
