package org.t2framework.lucy.config.meta.impl;

import java.util.concurrent.atomic.AtomicInteger;

/**
 * 
 * {@.en Constructor inject configuration.This instance is created when outer
 * configuration is used.}
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
public class ConstructorInjectConfig extends AbstractInjectConfig {

	protected AtomicInteger atomic = new AtomicInteger(0);

	public ConstructorInjectConfig() {
		this(false);
	}

	public ConstructorInjectConfig(boolean autoinjected) {
		super(autoinjected);
		incrementArgumentSize();
	}

	public void incrementArgumentSize() {
		atomic.getAndIncrement();
	}

	public int getArgumentSize() {
		return atomic.get();
	}
}
