package org.t2framework.lucy.config.meta.impl;

import java.lang.annotation.Annotation;

import org.t2framework.commons.meta.Config;
import org.t2framework.commons.meta.ConfigContainer;
import org.t2framework.commons.meta.ConfigType;
import org.t2framework.commons.util.Assertion;

/**
 * 
 * {@.en Simple delegate for outer configuration.}
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
public class OuterConfigDelegate implements Config {

	protected Class<?> type;

	protected ConfigType configType;

	protected ConfigContainer configContainer;

	public OuterConfigDelegate(Class<?> type, ConfigType configType) {
		this(type, configType, null);
	}

	public OuterConfigDelegate(Class<?> type, ConfigType configType,
			ConfigContainer configContainer) {
		this.type = Assertion.notNull(type);
		this.configType = configType;
		this.configContainer = configContainer;
	}

	@Override
	public Annotation getAnnotation() {
		return null;
	}

	@Override
	public ConfigType getConfigType() {
		return configType;
	}

	@Override
	public Class<?> getType() {
		return type;
	}

	@Override
	public boolean hasAnnotation() {
		return false;
	}

	@Override
	public ConfigContainer getConfigContainer() {
		return configContainer;
	}
}
