package org.t2framework.lucy.config.stax;

import org.t2framework.commons.el.Expression;
import org.t2framework.commons.el.spi.ExpressionFactory;
import org.t2framework.commons.module.Modules;
import org.t2framework.commons.util.StringUtil;
import org.t2framework.lucy.Lucy;

/**
 * The base class of {@link ExpressionHandler}.
 * 
 * @author shot
 * 
 */
public abstract class AbstractExpressionHandler implements
		ExpressionHandler<Lucy> {

	@SuppressWarnings("unchecked")
	protected ExpressionFactory<Lucy> expressionFactory = Modules
			.getService(ExpressionFactory.class);

	@Override
	public final ExpressionFactory<Lucy> getExpressionFactory() {
		return expressionFactory;
	}

	protected Expression<Lucy> getExpression(String body) {
		if (StringUtil.isEmpty(body)) {
			return null;
		}
		return getExpressionFactory().createExpression(body);
	}

	@Override
	public Object evaluateExpression(XmlEventContext context, String evalString) {
		Expression<Lucy> e = getExpression(evalString);
		return (e != null) ? e.evaluate(context.getLucy()) : null;
	}

}
