package org.t2framework.lucy.config.stax;

import org.t2framework.commons.el.spi.ExpressionFactory;

/**
 * ExpressionHandler is responsible for creating and evaluating expression.
 * 
 * @author shot
 * 
 * @param <C>
 *            as container.
 */
public interface ExpressionHandler<C> {

	/**
	 * Get {@link ExpressionFactory}.
	 * 
	 * @return
	 */
	ExpressionFactory<C> getExpressionFactory();

	/**
	 * Evaluate expression. If evalString is null or empty, simply return null
	 * and inherited class takes responsible for whatever it takes.
	 * 
	 * @param context
	 * @param evalString
	 * @return
	 */
	Object evaluateExpression(XmlEventContext context, String evalString);
}
