package org.t2framework.lucy.config.stax;

import org.t2framework.lucy.exception.IllegalELResultException;

/**
 * 
 * {@.en Include tag handler.}
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
public class IncludeTagHandler extends AbstractExpressionHandler implements
		XmlEventHandler {

	@Override
	public void start(XmlEventContext context, Attributes attributes) {
	}

	@Override
	public void end(XmlEventContext context, String body) {
		final String s = body.trim();
		final Object o = evaluateExpression(context, s);
		if (o == null) {
			throw new IllegalELResultException(s, o);
		}
		if (o instanceof String) {
			String path = (String) o;
			context.getLucy().load(path);
		} else {
			throw new IllegalELResultException(s, o);
		}
	}
}
