package org.t2framework.lucy.config.stax;

import org.t2framework.commons.module.Modules;

public class LucyConfigTagHandlerRule extends XmlEventHandlerRule {

	@SuppressWarnings("deprecation")
	public LucyConfigTagHandlerRule() {
		addHandler("lucy-config", new LucyConfigTagHandler());
		addHandler("include", new IncludeTagHandler());
		addHandler("component", new ComponentTagHandler());
		addHandler("components", new ComponentsTagHandler());
		addHandler("inject", new InjectTagHandler());
		addHandler("init", new InitTagHandler());
		addHandler("destroy", new DestroyTagHandler());
		setupExternalTagHandler();
	}

	protected void setupExternalTagHandler() {
		XmlEventHandler handler = Modules.getService(XmlEventHandler.class);
		if (handler != null) {
			addHandler("aspect", handler);
		}
	}
}
