package org.t2framework.lucy.el;

import java.util.Map;

import org.t2framework.commons.el.Expression;
import org.t2framework.commons.el.spi.ExpressionFactory;
import org.t2framework.commons.util.Assertion;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.el.mvel.MVELExpression;

/**
 * Abstract base class of {@link ExpressionFactory}.
 * 
 * @author shot
 * 
 */
public abstract class AbstractExpressionFactory implements
		ExpressionFactory<Lucy>, ExpressionNameResolver {

	/**
	 * Create {@link MVELExpression}.
	 */
	@Override
	public Expression<Lucy> createExpression(String source) {
		Assertion.notNull(source);
		final Map<String, Class<?>> namingContext = resolve();
		return doCreateExpression(source, namingContext);
	}

	protected abstract Expression<Lucy> doCreateExpression(String source,
			Map<String, Class<?>> namingContext);

	public abstract void setExpressionNameResolver(
			ExpressionNameResolver resolver);
}
