package org.t2framework.lucy.el;

import java.util.ArrayList;
import java.util.List;

import org.t2framework.commons.el.Expression;
import org.t2framework.commons.meta.ExpressionAware;
import org.t2framework.lucy.Lucy;

/**
 * {@link ExpressionUtil} is an utility class of evaluating all expression that
 * {@link ExpressionAware} instance has.
 * 
 * @author shot
 */
public class ExpressionUtil {

	/**
	 * Evaluate all expression.
	 * 
	 * @param aware
	 * @param lucy
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public static Object[] evaluateExpression(ExpressionAware aware, Lucy lucy) {
		List objects = new ArrayList();
		for (Expression expression : aware.getExpressions()) {
			objects.add(expression.evaluate(lucy));
		}
		return objects.toArray(new Object[objects.size()]);
	}

}
