package org.t2framework.lucy.el.mvel;

import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.t2framework.lucy.Lucy;

/**
 * Lucy map for mvel.
 * 
 * @author shot
 */
public class LucyComponentMap implements Map<String, Object> {

	public static final String KEY_LUCY = "lucy";

	protected Lucy lucy;

	protected Map<Object, Object> context = new HashMap<Object, Object>();

	public LucyComponentMap(Lucy lucy) {
		this.lucy = lucy;
	}

	@Override
	public void clear() {
	}

	@Override
	public boolean containsKey(Object key) {
		return KEY_LUCY.equals(key) || lucy.getBeanDesc(key) != null
				|| context.containsKey(key);

	}

	@Override
	public boolean containsValue(Object value) {
		return false;
	}

	@Override
	public Set<java.util.Map.Entry<String, Object>> entrySet() {
		return Collections.emptySet();
	}

	@Override
	public Object get(Object key) {
		if (KEY_LUCY.equals(key)) {
			return lucy;
		} else if (lucy.getBeanDesc(key) != null) {
			return lucy.get(key);
		}
		return this.context.get(key);
	}

	@Override
	public boolean isEmpty() {
		return false;
	}

	@Override
	public Set<String> keySet() {
		return Collections.emptySet();
	}

	@Override
	public Object put(String key, Object value) {
		return this.context.put(key, value);
	}

	@Override
	public void putAll(Map<? extends String, ? extends Object> m) {
		throw new UnsupportedOperationException();
	}

	@Override
	public Object remove(Object key) {
		return this.context.remove(key);
	}

	@Override
	public int size() {
		return context.size();
	}

	@Override
	public Collection<Object> values() {
		return Collections.emptyList();
	}
}
