package org.t2framework.lucy.el.mvel;

import java.io.Serializable;

import org.mvel2.MVEL;
import org.mvel2.ParserContext;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.el.AbstractLucyExpression;

/**
 * Mvel expression for {@link Lucy}.
 * 
 * @author shot
 * 
 */
public class MVELExpression extends AbstractLucyExpression {

	protected Serializable compiled;

	public MVELExpression(String source) {
		this(source, new ParserContext());
	}

	public MVELExpression(String source, ParserContext parserContext) {
		super(source);
		compiled = MVEL.compileExpression(source, parserContext);
	}

	/**
	 * Evaluate expression.
	 */
	@Override
	public Object evaluate(Lucy lucy) {
		return MVEL.executeExpression(compiled, new LucyComponentMap(lucy));
	}

}
