package org.t2framework.lucy.exception;

import org.t2framework.commons.util.Assertion;

/**
 * Exception for the target method is not found.
 * 
 * @author shot
 */
public class MethodNotFoundException extends LucyBaseRuntimeException {

	private static final long serialVersionUID = 1444059107210701494L;

	protected final Class<?> clazz;

	protected final String methodName;

	protected int lineNo;

	public MethodNotFoundException(Class<?> clazz, String methodName,
			int lineNo, int columnNo) {
		super("ELucyCore0006", clazz.getName(), methodName, lineNo, columnNo);
		this.clazz = Assertion.notNull(clazz);
		this.methodName = Assertion.notNull(methodName);
		this.lineNo = Assertion.notNull(lineNo);
	}
}
