package org.t2framework.lucy.impl;

import java.util.HashSet;
import java.util.Set;

import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.LucyComponentRegistrar;
import org.t2framework.lucy.config.stax.LucyConfigTagHandlerRule;
import org.t2framework.lucy.config.stax.StAXParser;

/**
 * ComponentRegistrar for external xml configuration.
 * 
 * @author shot
 */
public class XMLLucyComponentRegistrar implements
		LucyComponentRegistrar<String> {

	public static final String SUFFIX = ".xml";

	protected StAXParser parser = new StAXParser(new LucyConfigTagHandlerRule());

	protected Set<String> parsedPath = new HashSet<String>();

	public void setStAXParser(StAXParser parser) {
		this.parser = parser;
	}

	@Override
	public void register(Lucy lucy, String resource) {
		if (this.parsedPath.add(resource)) {
			parser.parse(lucy, resource);
		}
	}

	@Override
	public boolean accepts(Object resource) {
		if (!(resource instanceof String)) {
			return false;
		}
		return ((String) resource).endsWith(SUFFIX);
	}
}
