package org.t2framework.lucy.inject;

import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.exception.CyclicReferenceRuntimeException;

/**
 * 
 * {@.en {@link Injector} injects component using {@link Lucy} to the
 * instance.}
 * 
 * <br />
 * 
 * {@.ja {@link Injector}はコンポーネントへのインジェクトを実現します.}
 * 
 * @author shot
 * 
 */
public interface Injector {

	/**
	 * 
	 * {@.en Inject component from {@link Lucy} to the instance representing
	 * T.}
	 * 
	 * <br />
	 * 
	 * {@.ja コンポーネントTに対してインジェクトを行います.}
	 * 
	 * @param <T>
	 * @param t
	 * @param lucy
	 * @return
	 * @throws CyclicReferenceRuntimeException
	 */
	<T> T inject(T t, Lucy lucy) throws CyclicReferenceRuntimeException;
}
