package org.t2framework.lucy.inject;

import org.t2framework.commons.Constants;
import org.t2framework.commons.meta.BeanDesc;
import org.t2framework.lucy.Lucy;

/**
 * 
 * {@.en }
 * 
 * <br />
 * 
 * {@.ja デフォルトコンストラクタのみの場合の{@link Injector}です．
 * デフォルトコンストラクタのみの場合、コンストラクタインジェクションのための情報の収集などは必要ないため、このインジェクタで代用します．}
 * 
 * @author shot
 * 
 */
public class SimpleConstructorInjector extends AbstractInjector<BeanDesc<?>> {

	public SimpleConstructorInjector(BeanDesc<?> container) {
		super(container);
	}

	/**
	 * Simply create new instance using {@link BeanDesc#newInstance(Object...)}.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public <T> T inject(T t, Lucy lucy) {
		t = (T) getConfigContainer().newInstance(Constants.EMPTY_ARRAY);
		return t;
	}

	/**
	 * No setup needed.
	 */
	@Override
	protected void setup(BeanDesc<?> container) {
	}

}
