package org.t2framework.lucy.module;

import org.t2framework.commons.aop.AopEngine;
import org.t2framework.commons.meta.spi.AnnotationConfigSupport;
import org.t2framework.commons.module.Module;
import org.t2framework.lucy.config.stax.XmlEventHandler;
import org.t2framework.lucy.spi.Behavior;

/**
 * 
 * {@.en }
 * 
 * <br />
 * 
 * {@.ja LucyのAOPモジュールインタフェースです.AOPに必要なモジュールを提供します.}
 * 
 * @author shot
 * 
 */
public interface LucyAopModule extends Module {

	/**
	 * 
	 * {@.en Get aspect tag handler.}
	 * 
	 * <br />
	 * 
	 * {@.ja aspectタグのハンドラを返します．}
	 * 
	 * @return
	 */
	XmlEventHandler getAspectTagHandler();

	/**
	 * 
	 * {@.en Get class of aspect {@link Behavior}.}
	 * 
	 * <br />
	 * 
	 * {@.ja アスペクトエンハンス用の{@link Behavior}を返します.}
	 * 
	 * @return
	 */
	Class<? extends Behavior> getAspectBehaviorClass();

	/**
	 * 
	 * {@.en Get {@link AnnotationConfigSupport}, which is a helper class for
	 * annotation handling.}
	 * 
	 * <br />
	 * 
	 * {@.ja アノテーションのヘルパクラスである{@link AnnotationConfigSupport}を返します．}
	 * 
	 * @return
	 */
	AnnotationConfigSupport getAnnotationConfigSupport();

	/**
	 * 
	 * {@.en Get {@link AopEngine}, an engine class for aspect weaving.}
	 * 
	 * <br />
	 * 
	 * {@.ja AOPのコアエンジンの{@link AopEngine}を返します．}
	 * 
	 * @return
	 */
	AopEngine getAopEngine();
}
