package org.t2framework.lucy.module.impl;

import org.t2framework.commons.el.spi.ExpressionFactory;
import org.t2framework.lucy.el.AbstractExpressionFactory;
import org.t2framework.lucy.el.mvel.MVELExpressionFactory;
import org.t2framework.lucy.module.LucyCoreModule;

/**
 * 
 * {@.en }
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
public class LucyCoreModuleImpl implements LucyCoreModule {

	private static MVELExpressionFactory expressionFactory = new MVELExpressionFactory();

	@Override
	public AbstractExpressionFactory getExpressionFactory() {
		return expressionFactory;
	}

	@SuppressWarnings("unchecked")
	@Override
	public <S> S getService(Class<? super S> serviceClass) {
		if (ExpressionFactory.class.isAssignableFrom(serviceClass)) {
			return (S) getExpressionFactory();
		}
		return null;
	}

}
