package org.t2framework.lucy.spi;

import org.t2framework.commons.Disposable;
import org.t2framework.lucy.ConfigBindResult;
import org.t2framework.lucy.Lucy;

/**
 * ComponentBuilder is a SPI interface that builds a component using behaviors
 * from ConfigBindResult.
 * 
 * @author shot
 */
public interface ComponentBuilder extends Disposable {

	/**
	 * Build component.
	 * 
	 * @param <T>
	 * @param t
	 * @param result
	 * @return
	 */
	<T> T build(T t, final ConfigBindResult result);

	/**
	 * Set {@link Lucy}.
	 * 
	 * @param lucy
	 */
	void setLucy(final Lucy lucy);

	/**
	 * Load {@link LucyConfiguration}.
	 * 
	 * @param conf
	 * @return
	 */
	ComponentBuilder loadConfiguration(final LucyConfiguration conf);
}
